/*******************************************************************************
 * Copyright 2013 Thomas Letsch (contact@thomas-letsch.de)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.vaadin.addons.javaee.table;

import org.vaadin.addons.javaee.container.EntityContainer;

import com.googlecode.javaeeutils.jpa.PersistentEntity;

public class EntityTable<ENTITY extends PersistentEntity> extends BasicEntityTable<ENTITY> {

    private static final long serialVersionUID = 1L;

    private EntityContainer<ENTITY> entityContainer;

    public EntityTable() {
    }

    public EntityTable(Class<ENTITY> entityClass) {
        super(entityClass);
    }

    @Override
    public EntityContainer<ENTITY> getContainer() {
        return entityContainer;
    }

    public void setContainer(EntityContainer<ENTITY> entityContainer) {
        this.entityContainer = entityContainer;
    }

}
